c Generic analysis routine, expecially suited for comparisons
c at the parton level with MNR results,
c for charm, bottom and top
c


C----------------------------------------------------------------------
      subroutine abegin
c     user's routine for initialization
c----------------------------------------------------------------------
      implicit none
      real * 4 pi
      parameter (pi=3.141592653589793)
      character * 1 part
      include  'LesHouches.h'
      call inihist
      if(lprup(1).eq.1004) then
         part='D'
c     is charm
         call mbook(1,part//' pt ',0.2e0,0.e0,20.e0)
         call mbook(5,part//part//' inv m ',0.2e0,0.e0,20.e0)
         call mbook(7,part//part//' pt ',0.2e0,0e0,20e0)
      elseif(lprup(1).eq.1005)  then
         part='B'
c     is bottom
         call mbook(1,part//' pt ',0.5e0,0.e0,50.e0)
         call mbook(5,part//part//' inv m ',0.5e0,0.e0,50.e0)
         call mbook(7,part//part//' pt ',0.5e0,0e0,50e0)
      else
         part='l'
c     is a decayed top pair
         call mbook(1,part//' pt ',5.0e0,0.e0,500.e0)
         call mbook(5,part//part//' inv m ',5e0,0.e0,500.e0)
         call mbook(7,part//part//' pt ',1e0,0e0,100e0)
      endif
      call mbook(2,part//' y ',0.2e0,0.e0,4.e0)
      call mbook(3,part//part//' delta y  ',0.2e0,0.e0,4.e0)
      call mbook(4,part//part//' delta eta ',0.2e0,0.e0,4.e0)
      call mbook(6,part//part//' y ',0.2e0,0e0,4e0)
      call mbook(8,part//part//' azimt ',pi/20.e0,0.e0,pi)
      call mbook(9,part//part//' del R ',0.25e0,0.e0,10.e0)

      call mbook(190,'zeros',0.01e0,0.e0,1.e0)

      END

C----------------------------------------------------------------------
      SUBROUTINE aend
C     USER'S ROUTINE FOR TERMINAL CALCULATIONS, HISTOGRAM OUTPUT, ETC
C----------------------------------------------------------------------
      implicit none
      integer i,ii
      do i=1,200
        call mfinal(i)
      enddo
      open(unit=99,file='pwgoutput.top',status='unknown')
      call multitop(1,190,2,2,'','','LOG')
      call multitop(2,190,2,2,'','','LOG')
      call multitop(3,190,2,2,'','','LOG')
      call multitop(4,190,2,2,'','','LOG')
      call multitop(5,190,2,2,'','','LOG')
      call multitop(6,190,2,2,'','','LOG')
      call multitop(7,190,2,2,'','','LOG')
      call multitop(8,190,2,2,'','','LOG')
      call multitop(9,190,2,2,'','','LOG')
      close(99)
      END
C----------------------------------------------------------------------
      subroutine analize
      implicit none
c     user's routine to analyse data from event
C----------------------------------------------------------------------
c New standard event common
      integer NMXHEP,NEVHEP,NHEP,ISTHEP,IDHEP,
     & JMOHEP,JDAHEP
      double precision phep,vhep
      PARAMETER (NMXHEP=4000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      include  'LesHouches.h'
      real*8 mqq,ptqq,yq1,yq2,deltay,deltaeta,yqq,deltaphi,deltar,yq
      real*8 e1,e2,px1,px2,py1,py2,pz1,pz2,p1,p2,pt1,pt2,eta1,eta2,
     #       ptlept,pi,ptmax
      integer j
      integer khflav,ihf(100),klep,ilep(100)
      integer j1,j2,iquark
      integer idigit
      external idigit
      pi=acos(-1d0)
      if(lprup(1).le.1005) then
         iquark=lprup(1)-1000
      endif
      khflav=0
      klep=0
      j1=0
      j2=0
      do j=1,nhep
c Loop over final state particles
         if (isthep(j).eq.1) then
            if(lprup(1).le.1005) then
c     charm or bottom
               if(idigit(4,idhep(j)).eq.iquark) then
c     Particle j is a heavy flavoured baryon
                  khflav=khflav+1
                  ihf(khflav)=j
               elseif(idigit(4,idhep(j)).eq.0.and.
     #                 idigit(3,idhep(j)).eq.iquark) then
c     Particle j is a heavy flavoured meson
                  khflav=khflav+1
                  ihf(khflav)=j
               endif
            elseif( abs(idhep(j)).eq.11.or.
     #              abs(idhep(j)).eq.13.or.
     #              abs(idhep(j)).eq.15 ) then
c HVQ is a top and particle j is an electron
               klep=klep+1
               ilep(klep)=j
            endif
         endif
      enddo
      if(lprup(1).le.1005.and.khflav.gt.0) then
c The heavy flavour is either a c or b hadron,
c and there are only two heavy-flavoured hadrons in the final state.
         j1=ihf(1)
         if(khflav.eq.2) then
            j2=ihf(2)
         elseif(khflav.eq.1) then
            j2=0
         else
            return
         endif
      elseif(klep.gt.0)then
c There are no charm or bottom hadrons
c in the final state -> the heavy flavour is a decayed top.  
c Look for highest-pt electron:
         ptmax=30d0
         j1=0
         do j=1,klep
            ptlept=sqrt(phep(1,ilep(j))**2+phep(2,ilep(j))**2)
            if(ptlept.gt.ptmax)then
               j1=ilep(j)
               ptmax=ptlept
            endif
         enddo
         if(j1.eq.0) return
c Look for next-to-highest-pt electron:
         ptmax=30d0
         j2=0
         do j=1,klep
            ptlept=sqrt(phep(1,ilep(j))**2+phep(2,ilep(j))**2)
            if(ptlept.gt.ptmax.and.ilep(j).ne.j1)then
               j2=ilep(j)
               ptmax=ptlept
            endif
         enddo
      else
c more than 2 heavy flavour hadrons, or something wrong in the event
         return
      endif
      e1=phep(4,j1)
      px1=phep(1,j1)
      py1=phep(2,j1)
      pz1=phep(3,j1)
      p1=sqrt(px1**2+py1**2+pz1**2)
      pt1=sqrt(px1**2+py1**2)
      yq1=log((e1+pz1)/(e1-pz1))/2d0
      eta1=log((p1+pz1)/(p1-pz1))/2d0
      call mfill(1,sngl(pt1),1e0)
      call mfill(2,sngl(abs(yq1)),1e0)
      if(j2.ne.0) then
         e2=phep(4,j2)
         px2=phep(1,j2)
         py2=phep(2,j2)
         pz2=phep(3,j2)
         p2=sqrt(px2**2+py2**2+pz2**2)
         pt2=sqrt(px2**2+py2**2)
         ptqq=sqrt((px1+px2)**2+(py1+py2)**2)
         mqq=sqrt((e1+e2)**2-(px1+px2)**2-(py1+py2)**2-(pz1+pz2)**2)
         yq2=log((e2+pz2)/(e2-pz2))/2d0
         eta2=log((p2+pz2)/(p2-pz2))/2d0
         deltay=yq1-yq2
         deltaeta=eta1-eta2
         yqq=log((e1+e2+pz1+pz2)/(e1+e2-pz1-pz2))/2d0

         deltaphi=abs(atan2(px1,py1)-atan2(px2,py2))
         deltaphi=min(deltaphi,2*pi-deltaphi)
         deltar=sqrt(deltaeta**2+deltaphi**2)
         call mfill(1,sngl(pt2),1e0)
         call mfill(2,sngl(abs(yq2)),1e0)
         call mfill(5,sngl(mqq),1e0)
         call mfill(7,sngl(ptqq),1e0)
         call mfill(3,sngl(abs(deltay)),1e0)
         call mfill(4,sngl(abs(deltaeta)),1e0)
         call mfill(6,sngl(abs(yqq)),1e0)
         call mfill(8,sngl(deltaphi),1e0)
         call mfill(9,sngl(deltar),1e0)
      endif

 999  continue
      END

      function idigit(k,l)
      implicit none
      integer idigit,k,l
      idigit=abs(mod(l,10**k)/10**(k-1))
      end
