      PROGRAM HWIGPR
C---COMMON BLOCKS ARE INCLUDED AS FILE HERWIG65.INC
      INCLUDE 'HERWIG65.INC'
      include 'LesHouches.h'
      INTEGER N
      real * 8 powheginput
      EXTERNAL powheginput
C---PROCESS; set to negative for user supplied me
      iproc=-1                  ! Les Houches interface
C---MAX NUMBER OF EVENTS IN THIS RUN; must be set before HWIGIN call
      maxev=powheginput('maxev')
C---INITIALISE OTHER COMMON BLOCKS
      CALL HWIGIN
C---USER CAN RESET PARAMETERS AT
C   THIS POINT, OTHERWISE DEFAULT
C   VALUES IN HWIGIN WILL BE USED.
c      PTMIN=100.
C---COMPUTE PARAMETER-DEPENDENT CONSTANTS
      CALL HWUINC
C---CALL HWUSTA TO MAKE ANY PARTICLE STABLE
      CALL HWUSTA('PI0     ')
c      CALL HWUSTA('Z0/GAMA*')
C---USER'S INITIAL CALCULATIONS
      CALL abegin
C---INITIALISE ELEMENTARY PROCESS
      CALL HWEINI
C---LOOP OVER EVENTS
      DO 100 N=1,MAXEV
C---INITIALISE EVENT
      CALL HWUINE
C---GENERATE HARD SUBPROCESS
      CALL HWEPRO
C---GENERATE PARTON CASCADES
      CALL HWBGEN
C---DO HEAVY OBJECT DECAYS
      CALL HWDHOB
C---DO CLUSTER FORMATION
      CALL HWCFOR
C---DO CLUSTER DECAYS
      CALL HWCDEC
C---DO UNSTABLE PARTICLE DECAYS
      CALL HWDHAD
C---DO HEAVY FLAVOUR HADRON DECAYS
      CALL HWDHVY
C---ADD SOFT UNDERLYING EVENT IF NEEDED
      CALL HWMEVT
C---FINISH EVENT
      CALL HWUFNE
C---USER'S EVENT ANALYSIS
      CALL analize
  100 CONTINUE
C---TERMINATE ELEMENTARY PROCESS
      CALL HWEFIN
C---USER'S TERMINAL CALCULATIONS
      CALL aend
      call printstat
      END

      subroutine UPINIT
      include 'LesHouches.h'
      real * 8 powheginput
      external powheginput
      call pwhginit
      if(lprup(1).eq.1004) then
         call hwusta('D+      ')
         call hwusta('D-      ')
         call hwusta('D0      ')
         call hwusta('DBAR0   ')
      elseif(lprup(1).eq.1005) then
         call hwusta('B_D0    ')
         call hwusta('B_DBAR0 ')
         call hwusta('B-      ')
         call hwusta('B+      ')
      endif
      end

      subroutine UPEVNT
      call pwhgevnt
      end

c We need to include the follwing (called by HWGUP in Herwig)
      subroutine hwaend
      call aend
      end
