c routines
c mcatnloheader(iun)
c mcatnloevent(iun)
c to store header and events in mcatnlo file format.
c Reads all informations from Les Houches interface, plus:
c from powheginput.dat:
c topdecaymode, twidth, wmass, wwidth
c from common block iccode:
c mcatnlo colour code, computed specifically for this in leshouches-hvq.f
      subroutine mcatnloheader(iun)
      implicit none
      integer iun
      include 'fixvar-hvq.h'
      include 'strfun.h'
      real * 8 powheginput
      external powheginput
      real*8 twidth
      real*8 xmw,gaw
      real * 8 facscfact,renscfact,qmass,qmass2
c      real*8 xmass(-5:21)
      integer ihwproc,itopdecmode,maxev,iue
      common/cmcatnlofl/ihwproc,maxev,itopdecmode,iue
      integer il1hw,il2hw
      character * 4 part1,part2
c
      if(ih1.eq.1)part1='P'
      if(ih1.eq.-1)part1='PBAR'
      if(ih2.eq.1)part2='P'
      if(ih2.eq.-1)part2='PBAR'
      facscfact=powheginput('facscfact')
      renscfact=powheginput('renscfact')
      iue=powheginput('underlyingevent')
      if(iue.eq.0) then
         iue=-10000
      else
         iue=0
      endif
      qmass=powheginput('qmass')
      qmass2=qmass**2
      if(qmass2.lt.3**2) then
         ihwproc=-1704+iue
      elseif(xm2.lt.10**2) then
         ihwproc=-1705+iue
      else
         ihwproc=-1706+iue
      endif
      write(iun,801)
     #  sqrt(sh),renscfact,facscfact,renscfact,facscfact,
     #  '--> CM energy, muR/mu0[NLO], muF/mu0[NLO], '//
     #  'muR/mu0[MC], muF/mu0[MC]'
      write(iun,802)abs(ihwproc),'--> 1704/1705/1706=c/b/t'
      if(ihwproc.eq.-1704+iue)then
         write(iun,814)sqrt(xm2),'--> M_c'
      elseif(ihwproc.eq.-1705+iue)then
         write(iun,814)sqrt(xm2),'--> M_b'
      elseif(ihwproc.eq.-1706+iue) then
         itopdecmode=powheginput('#topdecaymode') 
         if(itopdecmode.ne.0.and.itopdecaymode.ne.-1000000) then
            il1hw=1
            il2hw=1
            twidth=powheginput('tdec/twidth')
            xmw=powheginput('tdec/wmass')
            gaw=powheginput('tdec/wwidth')         
         else
            il1hw=7
            il2hw=7
c the following informations not really needed; provide default values
            twidth=1.31d0
            xmw=80.4d0
            gaw=2.141d0
         endif
         write(iun,803)sqrt(xm2),twidth,
     #        '--> M_top, Gamma_top'
         write(iun,803)xmw,gaw,'--> M_W, Gamma_W'
         write(iun,810)il1hw,il2hw,'--> max e mu tau up charm'
      endif
      write(iun,804) 0d0,0d0,0d0,0d0,0d0,0d0,
     #                  '--> quark and gluon masses'
      write(iun,805)part1,part2,'--> colliding particles'
      write(iun,806)'PDFGROUP',ndns1,
     #  '--> PDF group and id number'
      write(iun,807)xlam,'MS','--> Lambda_5, scheme'
      write(iun,811)'P,M','--> Format of v3.1 and higher'
      maxev=powheginput('maxev') 
      write(iun,250)maxev
 250  format(1x,i8)
 801  format(5(1x,d10.4),1x,a)
 802  format(1x,i6,1x,a)
 803  format(2(1x,d10.4),1x,a)
 804  format(6(1x,d10.4),1x,a)
 805  format(2(1x,a4),1x,a)
 806  format(1x,a8,1x,i6,1x,a)
 807  format(1x,d10.4,1x,a2,1x,a)
 810  format(2(1x,i2),1x,a)
 811  format(1x,a3,1x,a)
 813  format(3(1x,d10.4),1x,a)
 814  format(1x,d10.4,1x,a)
      return
      end

      subroutine mcatnloevent(iun)
c Stores on disk the complete information on the events. Starting
c from version 3.1, each event has the following format:
c       IPR, IC, NP
c      (ID(I),I=1,NP)
c      ((P(J,I),J=1,4),I=1,NP)
c where IPR is the subprocess code (i1hpro), IC is the colour code
c (iccode, NON trivial here), NP is the number of partons entering the 
c reaction (thus, this includes the soft parton in the case of S events),
c ID(I) are the particle identities (ip1,...,ip9 here), and P(J,I) are 
c the particles four momenta in the lab frame (P(J,I)=xmom_lb(i,j) here).
c
c i1hpro has the following conventions:
c   i1hpro         process
c    401        q qbar -> g Q Qb
c    402        q g    -> q Q Qb
c    403        qbar q -> g Q Qb
c    404        qbar g -> qbar Q Qb
c    405        g q    -> q Q Qb
c    406        g qbar -> qbar Q Qb
c    407        g g    -> g Q Qb
c ipX is the parton code relevant to parton # X. PDG conventions are
c used: 1=d, 2=u, 3=s, 4=c, 5=b, 21=g. Note that, at variance with
c what happens for xmom_lb, in the case if ipX only the identities of
c final-state particles are kept. Thus, (ip4,ip5)=(Q,Qbar) identities
c when tops don't decay. But (ip4,ip5,ip6)=identities of top decay
c products, and (ip7,ip8,ip9)=identities of tbar decay products when
c tops decay. Order is lepton,neutrino,b quark
c iccode is the (internal) code which identifies the colour connection
c

      implicit none
      include 'LesHouches.h'
      integer iun
      integer ihwproc,itopdecmode,maxev,iue
      common/cmcatnlofl/ihwproc,maxev,itopdecmode,iue
      integer ip(9),id(9),i1hpro
      integer iccode
      common/ciccode/iccode
      integer np
      real*8 xmom(4,9),xwg
      integer ipart,j,k
      do ipart=1,9
         ip(ipart)=0
      enddo
      do ipart=1,nup
         if(istup(ipart).eq.-1) then
c     find incoming partons
           if(pup(3,ipart).gt.0) then
c incoming left
               ip(1)=ipart
            else
c incoming right
               ip(2)=ipart
            endif
         elseif(mothup(1,ipart).eq.1.or.mothup(1,ipart).eq.2) then
            if(abs(idup(ipart)).ne.abs(ihwproc+1700-iue)) then
c not a heavy quark; must be the radiated parton
               ip(3)=ipart
            elseif(nup.le.5) then
c no decay; must be the heavy quark
               if(idup(ipart).gt.0) then
                  ip(4)=ipart
               else
                  ip(5)=ipart
               endif
            endif
         elseif(abs(idup(mothup(1,ipart))).eq.6) then
c is a t or tbar decay product
            if(idup(ipart).eq.5) then
               ip(6)=ipart
            elseif(idup(ipart).eq.-5) then
               ip(9)=ipart
            endif
         elseif(idup(mothup(1,ipart)).eq.24) then
c son of a W+
            if((idup(ipart)/2)*2.ne.idup(ipart)) then
               ip(4)=ipart
            else
               ip(5)=ipart
            endif
         elseif(idup(mothup(1,ipart)).eq.-24) then
c son of a W-
            if((idup(ipart)/2)*2.ne.idup(ipart)) then
               ip(7)=ipart
            else
               ip(8)=ipart
            endif
         endif
      enddo
      np=0
      do j=1,9
         if(ip(j).ne.0) then
            np=np+1
            id(j)=idup(ip(j))
            do k=1,3
               xmom(k,j)=pup(k,ip(j))
            enddo
            xmom(4,j)=pup(5,ip(j))
         endif
      enddo
      if(ip(3).eq.0) then
         np=np+1
         do k=1,4
            xmom(k,3)=0
         enddo
         id(3)=21
      endif
      if(id(1).gt.0.and.id(1).ne.21) then
         if(id(2).lt.0) then
            i1hpro=401
         elseif(id(2).eq.21) then
            i1hpro=402
         else
            goto 998
         endif
      elseif(id(1).lt.0) then
         if(id(2).gt.0.and.id(2).ne.21) then
            i1hpro=403
         elseif(id(2).eq.21) then
            i1hpro=404
         else
            goto 998
         endif
      elseif(id(1).eq.21) then
         if(id(2).gt.0.and.id(2).ne.21) then
            i1hpro=405
         elseif(id(2).lt.0) then
            i1hpro=406
         elseif(id(2).eq.21) then
            i1hpro=407
         else
            goto 998
         endif
      endif          
      write(iun,901)i1hpro,iccode,np
      xwg=xsecup(1)/maxev
      if(np.eq.9)then
         write(iun,902)(id(j),j=1,9)
         write(iun,903)xwg,scalup
         write(iun,904)((xmom(k,j),k=1,4),j=1,9)
      else
         write(iun,902)(id(j),j=1,5)
         write(iun,903)xwg,scalup
         write(iun,904)((xmom(k,j),k=1,4),j=1,5)
      endif
 901  format(1x,i3,2(1x,i2))
 902  format(9(1x,i3))
 903  format(2(1x,d14.8))
 904  format(36(1x,d14.8))
      goto 999
 998  continue
      write(*,*) ' bad error in mcatnloevent; stopping'
      stop
 999  end
